<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api, api_key_tiny_editor } from "~/common/constaint";
import _, { cloneDeep } from "lodash";
@Component({
  components: {
    MediaPicker: () => import("../../../Gallery/MediaPicker/index.vue"),
  },
})
export default class AdminStoreFrontSlugComponent extends Vue {
  beforeDestroy() {
    this.$store.commit("adminGallery/setListCoverId", []);
    this.$store.commit("adminCollection/setCoverId", {
      coverId: "",
      imageUrl: "",
    });
  }
  config = {
    limit: 100,
    page: 1,
    search: "",
    type: "paypal",
  };
  api_key_tiny_editor = api_key_tiny_editor;
  resetContent = false;

  slug = "";
  description = "";
  domain: any = {};
  loading = false;
  tab = 0;

  // image banner & logo
  isImageVariant = false;
  tiptapWord = "";
  imageAdd = "";
  dialogMediaPicker = false;
  limitImage = true;
  isSelectMultipleImage = false;

  get listCoverId() {
    return this.$store.state.adminGallery.listCoverId || [];
  }

  // Logo
  get imageUrl() {
    return this.$store.state.adminCollection.imageUrl || "";
  }

  get coverId() {
    return this.$store.state.adminCollection.coverId || "";
  }

  get listPayment() {
    const listPayment = cloneDeep(this.$store.state.adminPayment.listPayment);
    return listPayment || [];
  }

  async created() {
    this.$store.commit("adminProduct/setLoadingFullPage", true);
    this.slug = this.$route.params.slug || "";
    const proms = [this.onGetDomainDetail(), this.onGetListPayment()];
    await Promise.all(proms);
    this.$store.commit("adminProduct/setLoadingFullPage", false);
  }

  async onGetListPayment() {
    this.$store.dispatch("adminPayment/onGetListPayment", {
      ctx: this,
      query: this.config,
    });
  }

  async onGetDomainDetail() {
    try {
      const response = await this.$api.setting.detailHomePage(this.slug);
      if (response?.data) {
        const data = response.data;
        this.domain = data;
        if (data.bannerId?.length) {
          this.$store.commit("adminGallery/setListCoverId", data.bannerId);
        }
        if (data.logoId?._id) {
          this.$store.commit("adminCollection/setCoverId", {
            coverId: data.logoId._id,
            imageUrl: data.logoId.imageUrl,
          });
        }
        if (data.paymentId?._id) {
          this.domain["paymentId"] = data.paymentId?._id;
        } else {
          this.domain["paymentId"] = "";
        }
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onSave() {
    try {
      if (!this.domain.domainId._id) {
        return this.$pushNotification.error("Cannot found domain id");
      }
      if (!this.domain["paymentId"]) {
        return this.$pushNotification.error("Please choose payment");
      }
      // if (!this.coverId) {
      //   return this.$pushNotification.error("Please choose logo");
      // }
      this.loading = true;
      const payload = {
        ...this.domain,
        logoId: this.coverId || "",
        bannerId: this.listCoverId.map((cover: any) => cover._id),
      };
      await this.$api.setting.updateDetailHomePage(
        this.domain.domainId._id,
        payload
      );
      this.$pushNotification.success("Update successfully");
      this.$store.commit("adminCollection/setCoverId", {
        coverId: "",
        imageUrl: "",
      });
      this.onGetDomainDetail();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  // image banner & logo
  onSelectMultipleImage() {
    this.limitImage = false;
    this.isSelectMultipleImage = true;
    this.dialogMediaPicker = true;
  }

  onSelectImage() {
    this.limitImage = true;
    this.isSelectMultipleImage = false;
    this.dialogMediaPicker = true;
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  onCopyText(text: string) {
    try {
      navigator.clipboard.writeText(text);
      this.onCopySuccess();
    } catch (error) {
      this.onCopyError();
    }
  }

  onCopySuccess() {
    this.$pushNotification.success("Copied successfully");
  }

  onCopyError() {
    this.$pushNotification.success("Copy failed");
  }

  get initEditor() {
    return {
      height: 400,
      image_title: true,
      automatic_uploads: true,
      //@ts-ignore
      file_picker_callback: function (cb, value, meta) {
        var input = document.createElement("input");
        input.setAttribute("type", "file");
        input.setAttribute("accept", "image/*");
        input.onchange = function () {
          //@ts-ignore
          var file = this.files[0];

          var reader = new FileReader();
          reader.onload = function () {
            var id = "blobid" + new Date().getTime();
            var blobCache =
              //@ts-ignore
              tinymce.activeEditor.editorUpload.blobCache;
            //@ts-ignore
            var base64 = reader.result.split(",")[1];
            var blobInfo = blobCache.create(id, file, base64);
            blobCache.add(blobInfo);
            cb(blobInfo.blobUri(), { title: file.name });
          };
          reader.readAsDataURL(file);
        };

        input.click();
      },
      file_picker_types: "image",
      plugins: ["lists link image code help wordcount paste"],
      toolbar:
        "undo redo | formatselect | bold italic | forecolor alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | image link media template codesample inserttable | charmap emoticons hr | pagebreak nonbreaking anchor toc | insertdatetime | help",
    };
  }
}
</script>

<style></style>
